var compose_addressbook_fetched = false;

if(window.rcmail) {
  rcmail.addEventListener('init', function(evt) {
    // create a button
    var button = $('<A>').attr('class', 'jqMdodal')
                         .attr('id', 'rcmbtn_compose_addressbook')
                         .attr('href', '#')
                         .attr('title', rcmail.gettext('compose_addressbook_buttontitle', 'compose_addressbook'))
                         .attr('label', 'asdf')
                         .html($('<IMG>').attr('src', 'plugins/compose_addressbook/images/compose_addressbook.gif'))
                         .html(rcmail.gettext('compose_addressbook_buttontitle', 'compose_addressbook'));
        
    // mode of operation. configure this in config.php
    var mode = rcmail.env.compose_addressbook_mode;
    
    // add the button to the toolbar
    $('#compose-toolbar').append(button);
    
    // register the toolbar button with RC
    rcmail.register_button('plugin.compose_addressbook', 'rcmbtn_compose_addressbook', 'link');
    
    // register the command associated with the toolbar button
    rcmail.register_command('plugin.compose_addressbook', compose_addressbook_fetch , true);
    
    // register the callback function 
    rcmail.addEventListener('plugin.compose_addressbook_receive', compose_addressbook_receive);
    
    // bind functions to the addressbook buttons
    $('#rcmbtn_compose_addressbook_to').bind('click', function(e) { return rcmail.command('plugin.compose_addressbook_to', '_to'); });
    $('#rcmbtn_compose_addressbook_cc').bind('click', function(e) { return rcmail.command('plugin.compose_addressbook_to', '_cc'); });
    $('#rcmbtn_compose_addressbook_bcc').bind('click', function(e) { return rcmail.command('plugin.compose_addressbook_to', '_bcc'); });
    
    // register the to/cc/bcc buttons
    rcmail.register_button('plugin.compose_addressbook_to', 'rcmbtn_compose_addressbook_to', 'link');
    rcmail.register_button('plugin.compose_addressbook_to', 'rcmbtn_compose_addressbook_cc', 'link');
    rcmail.register_button('plugin.compose_addressbook_to', 'rcmbtn_compose_addressbook_bcc', 'link');
    
    // register the function for the to/cc/bcc button
    rcmail.register_command('plugin.compose_addressbook_to', compose_addressbook_add_recipients , true);
    
    // start up the popup window plugin
    $('#compose_addressbook_modal').jqm({
                                      overlay: 0,
                                      trigger: '#rcmbtn_compose_addressbook',
                                      onShow: function(hash) {
                                        if(mode == 'full') rcmail.command('plugin.compose_addressbook', this);
                                        hash.w.show();
                                        $('.button').blur();
                                      },
                                      onHide: function(hash) {
                                        if(mode == 'full') {
                                          rcmail.compose_addressbook_list.clear_selection();
                                          $('#compose_addressbook_table tr').show();
                                          $('#compose_addressbook_filter').val('');
                                        } else {
                                          rcmail.compose_addressbook_list.clear();
                                          $('#compose_addressbook_filter').val('');
                                        }
                                        hash.w.hide();
                                      }
                                    });
                                  
    // make it draggable
    $("#compose_addressbook_modal").jqDrag('.jqdrag'); 
    
    // create an rc list object 
    if(rcmail.gui_objects.compose_addressbook_list) {
      rcmail.compose_addressbook_list = new rcube_list_widget(rcmail.gui_objects.compose_addressbook_list, {multiselect:true, draggable:false, keyboard:false});
      
      // add a listener for double click
      rcmail.compose_addressbook_list.addEventListener('dblclick', function(o){ compose_address_dblclick(o); });
      
      // initialize the list
      rcmail.compose_addressbook_list.init();  
    }  
    
    // each mode of operation has a different key handler
    if(mode == 'full') {
      // bind keyevent handler to the search box
      $('#compose_addressbook_filter').bind('keyup', function(evt) {
        var search = $('#compose_addressbook_filter').val();
        var regexp = new RegExp(search, 'i');
        $('#compose_addressbook_table').find('td').each(function() {
          var content = $(this).attr('title');
          if(regexp.test(content)) {
            $(this).parent().show();
          } else {
            $(this).parent().hide();
          }
        });
      });
    } else {
      $('#compose_addressbook_filter').bind((bw.safari || bw.ie ? 'keydown' : 'keypress'), function(evt) {
        var key = rcube_event.get_keycode(evt);
        if(key == 13) {
          var search = $('#compose_addressbook_filter').val();
          $('#compose_addressbook_filter').val('');
          compose_addressbook_search(search);
          return false;
        } else if (key == 27) {
          $('#compose_addressbook_modal').jqmHide();
          return false;
        }
      });
    }
    
    // bind click event to clear function
    $("#compose_addressbook_searchreset").bind('click', function(e) { 
      $('#compose_addressbook_filter').val('');
      $('#compose_addressbook_filter').focus();
      $('#compose_addressbook_table').find('tr').each(function() {
        $(this).show();
      });
    });
  });
}

function compose_addressbook_fetch() 
{
  if(!compose_addressbook_fetched) {
    rcmail.set_busy(true, 'loading');
    rcmail.http_post('plugin.get_addressbook', '', true);
    compose_addressbook_fetched = true;
  }
}

function compose_addressbook_search(search) 
{
  rcmail.compose_addressbook_list.clear();
  rcmail.set_busy(true, 'loading');
  rcmail.http_post('plugin.get_addressbook', '_search='+urlencode(search), true);
}

function compose_addressbook_receive(data) 
{
  var addresses = data.addresses;
  
  // save the addresses for later use
  rcmail.compose_addressbook_addresses = addresses;

  for(var j=0; j<addresses.length; j++) {
    var name = addresses[j].name;
    var email = addresses[j].email;
    
    // add address to the row
    compose_addressbook_add(name,email,j);    
  }
}

function compose_addressbook_add(address,email,id) {
  var row = document.createElement('tr');
  row.id = 'rcmrow'+id;
  td = document.createElement('td');
  td.innerHTML = address;
  td.setAttribute('title', email);
  td.style.cursor='pointer';
  row.appendChild(td);
  
  // add element to the list
  rcmail.compose_addressbook_list.insert_row(row,0);
}

function compose_address_dblclick(list) {
  var id = list.get_single_selection();
  if(id == null) return;
  
  var uid = list.rows[id].uid;
  $("[name='_to']").attr('value', $("[name='_to']").val() + rcmail.compose_addressbook_addresses[uid].email+", ");
  
  rcmail.compose_addressbook_list.clear_selection();
}

function compose_addressbook_add_recipients(target) {
  if(rcmail.compose_addressbook_list.selection.length == 0) {
    rcmail.display_message(rcmail.gettext('compose_addressbook_noselect', 'compose_addressbook'), 'error');
    return;
  }
  rcmail.compose_addressbook_list.focused = false;
  switch(target) {
    case '_cc':
      rcmail_show_header_form('cc');
      break;
    case '_bcc':
      rcmail_show_header_form('bcc');
      break;
  }
  for (var n=0; n<rcmail.compose_addressbook_list.selection.length; n++) {
    var id = rcmail.compose_addressbook_list.selection[n];
    var uid = rcmail.compose_addressbook_list.rows[id].uid;
    var form = '[name="'+target+'"]';
    
    $(form).attr('value', $(form).val() + rcmail.compose_addressbook_addresses[uid].email+", ");
  }
  rcmail.compose_addressbook_list.clear_selection();
  rcmail.display_message(rcmail.gettext('compose_addressbook_added', 'compose_addressbook'), 'confirmation');
}
